# coding: utf-8

"""
    Webhook Type Definition

    Webhook event definition of the LINE Messaging API  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic.v1 import Field, StrictInt
from linebot.v3.webhooks.models.membership_content import MembershipContent

class JoinedMembershipContent(MembershipContent):
    """
    JoinedMembershipContent
    """
    membership_id: StrictInt = Field(..., alias="membershipId", description="The ID of the membership that the user joined. This is defined for each membership.")
    type: str = "joined"

    __properties = ["type", "membershipId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> JoinedMembershipContent:
        """Create an instance of JoinedMembershipContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> JoinedMembershipContent:
        """Create an instance of JoinedMembershipContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return JoinedMembershipContent.parse_obj(obj)

        _obj = JoinedMembershipContent.parse_obj({
            "type": obj.get("type"),
            "membership_id": obj.get("membershipId")
        })
        return _obj

